//
//  AppDelegate.swift
//  DoHTestDemo
//
//  Created by 阿里 on 2021/2/3.
//
/**
 iOS 14 开始系统原生支持DoH规范的加密DNS并提供了两种设置加密DNS的方法。
 第一种方式是选择一个DNS服务器作为系统全局所有App默认的DNS解析器--systemAllAppLink();
 第二种方式是针对单个App的所有连接--allLinkInApp()或部分连接--oneLinkInApp()启用加密DNS。
 注意：1、需要真机运行。
      2、网络不要设置代理。
      3、将链接 https://9999.alidns.com/dns-query 中的9999替换为您在控制台注册应用时分配的AccountID
 */
import UIKit
@main
class AppDelegate: UIResponder, UIApplicationDelegate {

    func application(_ application: UIApplication, didFinishLaunchingWithOptions launchOptions: [UIApplication.LaunchOptionsKey: Any]?) -> Bool {
        // Override point for customization after application launch.
        
        let applink = appLink()
        //本app内所有连接
        //applink.allLinkInAppDoT()
        applink.allLinkInAppDoH()
        //本app内单个连接
        //applink.oneLinkInAppDoT()
        //applink.oneLinkInAppDoH()
        //系统全局内所有app连接，需要在 设置->通用->VPN & Network->DNS 手动启用
        //let systemApplink = allAppLink()
        //systemApplink.systemAllAppLinkDoT()
        //systemApplink.systemAllAppLinkDoH()
        return true
    }

    // MARK: UISceneSession Lifecycle

    func application(_ application: UIApplication, configurationForConnecting connectingSceneSession: UISceneSession, options: UIScene.ConnectionOptions) -> UISceneConfiguration {
        // Called when a new scene session is being created.
        // Use this method to select a configuration to create the new scene with.
        return UISceneConfiguration(name: "Default Configuration", sessionRole: connectingSceneSession.role)
    }

    func application(_ application: UIApplication, didDiscardSceneSessions sceneSessions: Set<UISceneSession>) {
        // Called when the user discards a scene session.
        // If any sessions were discarded while the application was not running, this will be called shortly after application:didFinishLaunchingWithOptions.
        // Use this method to release any resources that were specific to the discarded scenes, as they will not return.
    }


}

