//
//  appLink.swift
//  DoHTestDemo
//
//  Created by 阿里 on 2021/2/3.
//

import UIKit
import Network

class appLink: NSObject {
    // MARK: 设置在App范围内使用加密DNS,设置阿里云公共DNS解析
    func allLinkInAppDoT(){
        //设置在App范围内使用加密DNS,设置阿里云公共DNS解析
        //将 9999.alidns.com 中的9999替换为您在控制台注册应用时分配的AccountID
        let alidnsHost = NWEndpoint.hostPort(host: "9999.alidns.com", port: 853)
        let address1 = NWEndpoint.hostPort(host: "223.5.5.5", port: 853)
        let address2 = NWEndpoint.hostPort(host: "223.6.6.6", port: 853)
        let address3 = NWEndpoint.hostPort(host: "2400:3200::1", port: 853)
        let address4 = NWEndpoint.hostPort(host: "2400:3200:baba::1", port: 853)
        NWParameters.PrivacyContext.default.requireEncryptedNameResolution(true, fallbackResolver: .tls(alidnsHost, serverAddresses: [address1,address2,address3,address4]))
        //    验证是否生效
        self.saveToPreferences()
    }
    func allLinkInAppDoH(){
        //设置在App范围内使用加密DNS,设置阿里云公共DNS解析
        //将 https://9999.alidns.com/dns-query 中的9999替换为您在控制台注册应用时分配的AccountID
        if let aliurl = URL(string: "https://9999.alidns.com/dns-query"){
            let address1 = NWEndpoint.hostPort(host: "223.5.5.5", port: 443)
            let address2 = NWEndpoint.hostPort(host: "223.6.6.6", port: 443)
            let address3 = NWEndpoint.hostPort(host: "2400:3200::1", port: 443)
            let address4 = NWEndpoint.hostPort(host: "2400:3200:baba::1", port: 443)
            NWParameters.PrivacyContext.default.requireEncryptedNameResolution(true, fallbackResolver: .https(aliurl, serverAddresses: [address1,address2,address3,address4]))
            }
        //    验证是否生效
        self.saveToPreferences()
    }

    func saveToPreferences()
    {
        let tlsParams = NWParameters.tls
        let conn = NWConnection(host: "www.360.com", port: 443, using: tlsParams)
        conn.stateUpdateHandler = {(newState) in
                    switch (newState)
                        {
                        case .ready:
                            //The connection is established and ready to send and recieve data.
                            print("ready")
                            self.readyAction(conn: conn)
                        case .setup:
                            //The connection has been initialized but not started
                            print("setup")
                        case .cancelled:
                            //The connection has been cancelled
                            print("cancelled")
                        case .preparing:
                            //The connection in the process of being established
                            print("Preparing")
                        default:
                            //The connection has disconnected or encountered an error
                            print("waiting or failed")
                        }
        }
        conn.start(queue: .main)
    }
    
    func readyAction(conn:NWConnection)
    {
        conn.requestEstablishmentReport(queue: .main) { report in
            if let report = report {
                self.requestEstablishmentReport(report: report)
            }
        }
    }
    
    func requestEstablishmentReport(report:NWConnection.EstablishmentReport)
    {
        for resolution in report.resolutions {
            switch resolution.dnsProtocol {
            case .https, .tls:
                print("Used encrypted DNS!")
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "changelabel"), object: "Used encrypted DNS!")
                break
            case .udp, .tcp:
                print("Used unencrypted DNS!")
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "changelabel"), object: "Used unencrypted DNS!")
                break
            default:
                print("Used unknown dnsProtocol!")
                NotificationCenter.default.post(name: NSNotification.Name(rawValue: "changelabel"), object: "Used unknown dnsProtocol!")
                break
            }
        }
    }
    
    // MARK: 对单个连接使用加密DNS，设置阿里云公共DNS解析
    func oneLinkInAppDoT(){
        //对单个连接使用加密DNS，设置阿里云公共DNS解析
        let privacyContext = NWParameters.PrivacyContext(description: "EncryptedDNS")
        //将链接 https://9999.alidns.com/dns-query 中的9999替换为您在控制台注册应用时分配的AccountID
        let alidnsHost = NWEndpoint.hostPort(host: "9999.alidns.com", port: 853)
        let address1 = NWEndpoint.hostPort(host: "223.5.5.5", port: 853)
        let address2 = NWEndpoint.hostPort(host: "223.6.6.6", port: 853)
        let address3 = NWEndpoint.hostPort(host: "2400:3200::1", port: 853)
        let address4 = NWEndpoint.hostPort(host: "2400:3200:baba::1", port: 853)
        privacyContext.requireEncryptedNameResolution(true, fallbackResolver: .tls(alidnsHost, serverAddresses: [address1,address2,address3,address4]))
        
        //   验证是否生效
        self.saveToPrivacyContextPreferences(privacyContext: privacyContext)
    }
    func oneLinkInAppDoH(){
        //对单个连接使用加密DNS，设置阿里云公共DNS解析
        let privacyContext = NWParameters.PrivacyContext(description: "EncryptedDNS")
        //将链接 https://9999.alidns.com/dns-query 中的9999替换为您在控制台注册应用时分配的AccountID
        if let url = URL(string: "https://9999.alidns.com/dns-query") {
            let address1 = NWEndpoint.hostPort(host: "223.5.5.5", port: 443)
            let address2 = NWEndpoint.hostPort(host: "223.6.6.6", port: 443)
            let address3 = NWEndpoint.hostPort(host: "2400:3200::1", port: 443)
            let address4 = NWEndpoint.hostPort(host: "2400:3200:baba::1", port: 443)
            privacyContext.requireEncryptedNameResolution(true, fallbackResolver: .https(url, serverAddresses: [address1,address2,address3,address4]))
        }
        //   验证是否生效
        self.saveToPrivacyContextPreferences(privacyContext: privacyContext)
    }
    
    func saveToPrivacyContextPreferences(privacyContext:NWParameters.PrivacyContext)
    {
        let tlsParams = NWParameters.tls
        tlsParams.setPrivacyContext(privacyContext)
        let conn = NWConnection(host: "www.aliyun.com", port: 443, using: tlsParams)
        conn.stateUpdateHandler = {(newState) in
                    switch (newState)
                        {
                        case .ready:
                            //The connection is established and ready to send and recieve data.
                            print("ready")
                            self.readyAction(conn: conn)
                            //发送数据
                            //self.send(conn: conn)
                            //接收数据
                            //self.receiveMessage(conn: conn)
                        case .setup:
                            //The connection has been initialized but not started
                            print("setup")
                        case .cancelled:
                            //The connection has been cancelled
                            print("cancelled")
                        case .preparing:
                            //The connection in the process of being established
                            print("Preparing")
                        default:
                            //The connection has disconnected or encountered an error
                            print("waiting or failed")
                        }
                }
        conn.start(queue: .main)
    }
    
    func send(conn:NWConnection)
    {
        let packet:String
        packet = "123"
        let packetData = packet.data(using: .utf8)
        conn.send(content: packetData, completion: NWConnection.SendCompletion.contentProcessed(({ (error) in
            if let err = error {
                print("Sending error \(err)")
            } else {
                print("Sent successfully")
            }
        })))
    }
    
    func receiveMessage(conn:NWConnection)
    {
        conn.receiveMessage(completion:
        {
                (data, context, isComplete, error) in
                print("Got it")
                if let err = error {
                    print("Recieve error: \(err)")
                }

                if let rcvData = data,
                    let str = String(data:rcvData, encoding: .utf8) {
                    print("Received: \(str)")
                }
        })
    }
    

}


